/*
 * irmp_translate.c
 *
 * Created: 09.07.2018 12:26:10
 *  Author: peter
 */ 
/* Soft config: CPU Attiny85 8 MHz internal osc, BOD 4.3V

In irsndconfig.h: #  define IRSND_OCx                           IRSND_OC0A              // use OC0A

In irmpconfig.h: # define IRMP_PORT_LETTER						B
				 # define IRMP_BIT_NUMBER						3

and in both files: F_INTERRUPTS									15000

*/

#include "main.h"
#include "timebase.h"
#include "irmp.h"
#include "irsnd.h"

translation_t ttable[25]={
	
	{ OPT_POWER, ASUS_POWER},
	{ OPT_TV_RADIO, ASUS_DISPLAY},
	{ OPT_PAUSE_PLAY, ASUS_PAUSE_PLAY},
	{ OPT_USB_PAUSE, ASUS_PAUSE},
	{ OPT_SKIP_BACKWARD, ASUS_SKIP_BACKWARD},
	{ OPT_SKIP_FORWARD, ASUS_SKIP_FORWARD},
	{ OPT_NEXT_BACK, ASUS_NEXT_BACK},
	{ OPT_NEXT_FORWARD, ASUS_NEXT_FORWARD},
	{ OPT_FAVORITES, ASUS_HOME},
	{ OPT_EXIT, ASUS_RETURN},
	{ OPT_UP, ASUS_UP},
	{ OPT_DOWN, ASUS_DOWN},
	{ OPT_LEFT, ASUS_LEFT},
	{ OPT_RIGHT, ASUS_RIGHT},
	{ OPT_OK, ASUS_OK},
	{ OPT_PAGE_PLUS, ASUS_VOL_PLUS},
	{ OPT_PAGE_MINUS, ASUS_VOL_MINUS},
	{ OPT_MENU, ASUS_SETUP},
	{ OPT_SAT, ASUS_MODE},
	{ OPT_AUDIO, ASUS_AUDIO},
	{ OPT_INFO, ASUS_Aa},
	{ OPT_MUTE, ASUS_MUTE},
	{ OPT_EPG, ASUS_SWAP},
	{ OPT_RECALL, ASUS_ZOOM},
	{ END_OF_TABLE, END_OF_TABLE},
};

volatile uint8_t bled=0;		// Strobe within ISR of IRMP
//volatile uint8_t snd_wait=0;	// wait before sending the translated code to the device

uint8_t search_command(uint16_t command);

int main(void)
{
	
	IRMP_DATA   irmp_data_in;
	IRMP_DATA	irmp_data_out;

	uint8_t	idx;
	
	LED_DDR |= ( 1 << LED_PIN);		// Set as output
	LED_PORT &= ~(1 << LED_PIN);	// Make sure it is off 
	bled = 0;
	
	
	
	irmp_init();
	irsnd_init();
	init_timer();					// init to 15 kHz timer1 CTC

	
	

   while(1)
    {
		
/*		// Test case
		irmp_data_out.address = ASUS_ADDRESS;
		irmp_data_out.command = ASUS_POWER;
		irmp_data_out.protocol = 0x02; // NEC
		irmp_data_out.flags = 0; //irmp_data_in.flags;
		
		irsnd_send_data(&irmp_data_out,TRUE);			// Wait until send
		_delay_ms(500);
		irmp_data_out.address = ASUS_ADDRESS;
		irmp_data_out.command = ASUS_VOL_PLUS;
		irmp_data_out.protocol = 0x02; // NEC
		irmp_data_out.flags = 0; //irmp_data_in.flags;
		irsnd_send_data(&irmp_data_out,TRUE);			// Wait until send		
		_delay_ms(500); */

		
	   	if (irmp_get_data (&irmp_data_in)){
		   		if ( irmp_data_in.address == OPT_ADDRESS ){
									
								
													
								idx = search_command(irmp_data_in.command);
								
								if ( idx != END_OF_TABLE){
									
												bled = 1;		// wait state a while before sending anything	
												
												irmp_data_out.address = ASUS_ADDRESS;
												irmp_data_out.command = ttable[idx].out_command;
												irmp_data_out.protocol = irmp_data_in.protocol;
												irmp_data_out.flags = 0; //irmp_data_in.flags;
												while ( bled );
												irsnd_send_data(&irmp_data_out,TRUE);			// Wait until send
												
								}
							
				}
		   }
			
	 }  // while 
}

uint8_t search_command(uint16_t command){
	
	
	uint8_t idx;
	
	for(idx=0; ttable[idx].in_command != END_OF_TABLE; idx++){
		
				if ( ttable[idx].in_command == command)
							return(idx);
	}
	return(END_OF_TABLE);
}
				
