/*
 * main.h
 *
 * Created: 14.5.2018 14:13:03
 *  Author: peter
 */ 
#include <stddef.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>



#ifndef MAIN_H_
#define MAIN_H_



// I/O Ports

#define LED_PORT	PORTB
#define LED_DDR		DDRB
#define LED_PIN		PB4

// IRMP 
// ASUS O!Play AIR HDP R3/2A
// PROTOCOL NEC
#define ASUS_ADDRESS	0x686c
// Commands
#define ASUS_POWER				0x56
#define ASUS_DISPLAY 			0x54
#define ASUS_SKIP_BACKWARD		0x41
#define ASUS_PAUSE_PLAY			0x18
#define ASUS_SKIP_FORWARD		0x17
#define ASUS_NEXT_BACK			0x19
#define ASUS_PAUSE				0x04
#define ASUS_NEXT_FORWARD		0x13
#define ASUS_HOME				0x40
#define ASUS_RETURN				0x44
#define ASUS_UP					0x5e
#define ASUS_DOWN				0x5c
#define ASUS_LEFT				0x58
#define ASUS_RIGHT				0x5f
#define ASUS_OK					0x5d
#define ASUS_VOL_PLUS			0x1b
#define ASUS_VOL_MINUS			0x4c
#define ASUS_SETUP				0x45
#define ASUS_MODE				0x49
#define ASUS_AUDIO				0x05
#define ASUS_Aa					0x5b
#define ASUS_MUTE				0x57
#define ASUS_SWAP				0x5a		// Key with two arrows 
#define ASUS_ZOOM				0x42		// Magnifiying lens symbol

// END OF ASUS

// OPTICUM HD AX300 mini
// PROTOCOL NEC
#define OPT_ADDRESS				0xfd01
// Commands
#define OPT_POWER				0xdc
#define OPT_MUTE				0x8b
#define OPT_PAUSE_PLAY			0xc9
#define OPT_USB_PAUSE			0xc8
#define OPT_RECORD				0x99
#define OPT_INFO				0xcd
#define OPT_SKIP_BACKWARD		0xc7
#define OPT_SKIP_FORWARD		0xc6
#define OPT_NEXT_BACK			0xc5
#define OPT_NEXT_FORWARD		0xc4
#define OPT_FAVORITES			0x9f
#define OPT_SAT					0x9b
#define OPT_UP					0xde
#define OPT_LEFT				0xdb
#define OPT_RIGHT				0xd8
#define OPT_DOWN				0xd6
#define OPT_OK					0xda
#define OPT_MENU				0xd4
#define OPT_EXIT				0xd7
#define OPT_SUBTITLE			0x9d
#define OPT_TEXT				0xdd
#define OPT_RECALL				0x83
#define OPT_AUDIO				0xce
#define OPT_PAGE_PLUS			0xd0
#define OPT_PAGE_MINUS			0xcc
#define OPT_1					0x8e
#define OPT_2					0x86
#define OPT_3					0x8f
#define OPT_4					0x92
#define OPT_5					0x87
#define OPT_6					0x93
#define OPT_7					0x96
#define OPT_8					0x82
#define OPT_9					0x97
#define OPT_EPG					0xdf
#define OPT_0					0x9a
#define OPT_TV_RADIO			0x89
// END OPTICUM

#define END_OF_TABLE			0xff

typedef struct translation {
	
	uint16_t	in_command;
	uint16_t	out_command;
	} translation_t;
	

		


#endif /* MAIN_H_ */