/* timebase.c */

#include "main.h"
#include "irmp.h"
#include "irsnd.h"

extern volatile uint8_t bled;


ISR(TIMER1_COMPA_vect){			// called every 67 us -> 15x 67us = 1ms (more or less) ;-)
	

	static uint16_t blink=0;

	
	if (! irsnd_ISR())				// call irsnd ISR
	{									// if not busy...
	  if ( bled == 0)				// if waiting do not call irmp
	  irmp_ISR();					// call irmp ISR
	}

//	LED_PORT ^= ( 1 << LED_PIN);

  if ( bled ){
	  blink++;
	  LED_PORT |= ( 1 << LED_PIN);				// LED ON for round about 200 ms
	  if ( blink > 3500){
			  LED_PORT &= ~( 1 << LED_PIN);		// LED OFF
			  bled = 0;
			  blink = 0;	
	  }
  }
}
void init_timer( void )	// Timer 1
{
		
 
	 /* Init  timer1 */
	 /* Enable interrput */

	TIMSK |= ( 1 << OCIE1A );	// Enable interrupt for OCR0A Timer 0

	 // This is the counter for irmp receiver
	 TCCR1 |= (( 1 << CTC1 ) | (1 << CS12 ));   // CTC Mode and Prescaler 8
												// CTC Mode compares with OCR1C
												// but the interrupt is OCIE1A !!!!

	 TCNT1 = 0; 							 // Set to zero
	 OCR1C = ((F_CPU / 8 ) / F_INTERRUPTS ) - 1; 			 // 1 MHz input clock for this timer
															
	 
	sei(); // let the ball roll

}
